<html>
<head>
<title>OgreGLES2HardwareBufferManager.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_740c5ae02f3e58539fc77518d7d26661.html">GLES2</a>      </li>
      <li class="navelem"><a class="el" href="dir_03408e7e26591a021d5048c9e4238005.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLES2HardwareBufferManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLES2HardwareBufferManager_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __GLES2HardwareBufferManager_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __GLES2HardwareBufferManager_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLES2Prerequisites_8h.html">OgreGLES2Prerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareBufferManager_8h.html">OgreHardwareBufferManager.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036     <span class="comment">// Default threshold at which glMapBuffer becomes more efficient than glBufferSubData (32k?)</span>
<a name="l00037"></a><a class="code" href="OgreGLES2HardwareBufferManager_8h.html#aae90f8b1399ebc9b28abb1a0c4ef8426">00037</a> <span class="preprocessor">    #   define OGRE_GL_DEFAULT_MAP_BUFFER_THRESHOLD (1024 * 32)</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00040"></a><a class="code" href="classOgre_1_1GLES2HardwareBufferManagerBase.html">00040</a>     <span class="keyword">class </span><a class="code" href="OgreGLES2Prerequisites_8h.html#a3f2e060c56216a4f3fb7650e502f5735">_OgreGLES2Export</a> <a class="code" href="classOgre_1_1GLES2HardwareBufferManagerBase.html" title="Implementation of HardwareBufferManager for OpenGL ES.">GLES2HardwareBufferManagerBase</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>
<a name="l00041"></a>00041     {
<a name="l00042"></a>00042         <span class="keyword">protected</span>:
<a name="l00043"></a><a class="code" href="classOgre_1_1GLES2HardwareBufferManagerBase.html#abb7374117c6bc1606fff5d20e34e6cbf">00043</a>             <span class="keywordtype">char</span>* <a class="code" href="classOgre_1_1GLES2HardwareBufferManagerBase.html#abb7374117c6bc1606fff5d20e34e6cbf">mScratchBufferPool</a>;
<a name="l00044"></a>00044             <a class="code" href="OgrePrerequisites_8h.html#a2fb96ea8ad9700f804480d1d7f5d692d">OGRE_MUTEX</a>(mScratchMutex)
<a name="l00045"></a><a class="code" href="classOgre_1_1GLES2HardwareBufferManagerBase.html#ab846c14c38d001577e1d75f21cb1a3b2">00045</a>             size_t mMapBufferThreshold;
<a name="l00046"></a>00046 
<a name="l00047"></a>00047         public:
<a name="l00048"></a>00048             <a class="code" href="classOgre_1_1GLES2HardwareBufferManagerBase.html" title="Implementation of HardwareBufferManager for OpenGL ES.">GLES2HardwareBufferManagerBase</a>();
<a name="l00049"></a>00049             virtual ~GLES2HardwareBufferManagerBase();
<a name="l00051"></a>00051             <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> createVertexBuffer(<span class="keywordtype">size_t</span> vertexSize,
<a name="l00052"></a>00052                 <span class="keywordtype">size_t</span> numVerts, <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>::Usage usage, <span class="keywordtype">bool</span> useShadowBuffer = false);
<a name="l00054"></a>00054             <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a> createIndexBuffer(
<a name="l00055"></a>00055                 <a class="code" href="classOgre_1_1HardwareIndexBuffer.html" title="Specialisation of HardwareBuffer for vertex index buffers, still abstract.">HardwareIndexBuffer</a>::IndexType itype, <span class="keywordtype">size_t</span> numIndexes,
<a name="l00056"></a>00056                 <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>::Usage usage, <span class="keywordtype">bool</span> useShadowBuffer = false);
<a name="l00058"></a>00058             <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">RenderToVertexBufferSharedPtr</a> createRenderToVertexBuffer();
<a name="l00059"></a>00059 
<a name="l00061"></a>00061             static GLenum getGLUsage(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> usage);
<a name="l00062"></a>00062 
<a name="l00064"></a>00064             static GLenum getGLType(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> type);
<a name="l00065"></a>00065 
<a name="l00073"></a>00073             <span class="keywordtype">void</span>* allocateScratch(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> size);
<a name="l00074"></a>00074 
<a name="l00076"></a>00076             <span class="keywordtype">void</span> deallocateScratch(<span class="keywordtype">void</span>* ptr);
<a name="l00077"></a>00077 
<a name="l00080"></a>00080             <span class="keywordtype">size_t</span> getGLMapBufferThreshold() const;
<a name="l00081"></a>00081             <span class="keywordtype">void</span> setGLMapBufferThreshold( const <span class="keywordtype">size_t</span> value );
<a name="l00082"></a>00082     };
<a name="l00083"></a>00083 
<a name="l00085"></a><a class="code" href="classOgre_1_1GLES2HardwareBufferManager.html">00085</a>     class <a class="code" href="OgreGLES2Prerequisites_8h.html#a3f2e060c56216a4f3fb7650e502f5735">_OgreGLES2Export</a> <a class="code" href="classOgre_1_1GLES2HardwareBufferManager.html" title="GLES2HardwareBufferManagerBase as a Singleton.">GLES2HardwareBufferManager</a> : public <a class="code" href="classOgre_1_1HardwareBufferManager.html" title="Singleton wrapper for hardware buffer manager.">HardwareBufferManager</a>
<a name="l00086"></a>00086     {
<a name="l00087"></a>00087     <span class="keyword">public</span>:
<a name="l00088"></a><a class="code" href="classOgre_1_1GLES2HardwareBufferManager.html#abd23f216b504a85503269e332813047b">00088</a>         <a class="code" href="classOgre_1_1GLES2HardwareBufferManager.html" title="GLES2HardwareBufferManagerBase as a Singleton.">GLES2HardwareBufferManager</a>()
<a name="l00089"></a>00089             : HardwareBufferManager(<a class="code" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">OGRE_NEW</a> GLES2HardwareBufferManagerBase()) 
<a name="l00090"></a>00090         {
<a name="l00091"></a>00091 
<a name="l00092"></a>00092         }
<a name="l00093"></a><a class="code" href="classOgre_1_1GLES2HardwareBufferManager.html#ab151e77501b2adb041d892412e06aee2">00093</a>         ~<a class="code" href="classOgre_1_1GLES2HardwareBufferManager.html" title="GLES2HardwareBufferManagerBase as a Singleton.">GLES2HardwareBufferManager</a>()
<a name="l00094"></a>00094         {
<a name="l00095"></a>00095             <a class="code" href="group__Memory.html#gad18eff671a00617b21c8e35a7f545690">OGRE_DELETE</a> mImpl;
<a name="l00096"></a>00096         }
<a name="l00097"></a>00097 
<a name="l00099"></a><a class="code" href="classOgre_1_1GLES2HardwareBufferManager.html#a5d3ce6574d27bd52d49fc0084ac37753">00099</a>         <span class="keyword">static</span> GLenum getGLUsage(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> usage) 
<a name="l00100"></a>00100             { <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1GLES2HardwareBufferManagerBase.html#a5b0e32ef12026a8ade2e2836938b4119" title="Utility function to get the correct GL usage based on HBU&#39;s.">GLES2HardwareBufferManagerBase::getGLUsage</a>(usage); }
<a name="l00101"></a>00101 
<a name="l00103"></a><a class="code" href="classOgre_1_1GLES2HardwareBufferManager.html#a50ae258d8391b110664ed15b97026d11">00103</a>         <span class="keyword">static</span> GLenum getGLType(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> type)
<a name="l00104"></a>00104             { <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1GLES2HardwareBufferManagerBase.html#a069b57d513f5c463cab14c7d21696ae5" title="Utility function to get the correct GL type based on VET&#39;s.">GLES2HardwareBufferManagerBase::getGLType</a>(type); }
<a name="l00105"></a>00105 
<a name="l00113"></a><a class="code" href="classOgre_1_1GLES2HardwareBufferManager.html#a5e815373553574b8c4d81efd7e2d8541">00113</a>         <span class="keywordtype">void</span>* allocateScratch(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> size)
<a name="l00114"></a>00114         {
<a name="l00115"></a>00115             <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>GLES2HardwareBufferManagerBase*<span class="keyword">&gt;</span>(mImpl)-&gt;allocateScratch(size);
<a name="l00116"></a>00116         }
<a name="l00117"></a>00117 
<a name="l00119"></a><a class="code" href="classOgre_1_1GLES2HardwareBufferManager.html#ac4ec996e0bf9c9f9a1d837193d3b33bc">00119</a>         <span class="keywordtype">void</span> deallocateScratch(<span class="keywordtype">void</span>* ptr)
<a name="l00120"></a>00120         {
<a name="l00121"></a>00121             <span class="keyword">static_cast&lt;</span>GLES2HardwareBufferManagerBase*<span class="keyword">&gt;</span>(mImpl)-&gt;deallocateScratch(ptr);
<a name="l00122"></a>00122         }
<a name="l00123"></a>00123 
<a name="l00126"></a><a class="code" href="classOgre_1_1GLES2HardwareBufferManager.html#aad34630496499f6435e61bacffe06b3c">00126</a>         <span class="keywordtype">size_t</span> getGLMapBufferThreshold()<span class="keyword"> const</span>
<a name="l00127"></a>00127 <span class="keyword">        </span>{
<a name="l00128"></a>00128             <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>GLES2HardwareBufferManagerBase*<span class="keyword">&gt;</span>(mImpl)-&gt;getGLMapBufferThreshold();
<a name="l00129"></a>00129         }
<a name="l00130"></a><a class="code" href="classOgre_1_1GLES2HardwareBufferManager.html#a5a6cf9f3e489a3ebff35665d01d71e66">00130</a>         <span class="keywordtype">void</span> setGLMapBufferThreshold( <span class="keyword">const</span> <span class="keywordtype">size_t</span> value )
<a name="l00131"></a>00131         {
<a name="l00132"></a>00132             <span class="keyword">static_cast&lt;</span>GLES2HardwareBufferManagerBase*<span class="keyword">&gt;</span>(mImpl)-&gt;setGLMapBufferThreshold(value);
<a name="l00133"></a>00133         }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135     };
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
